
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <mylib.h>
#include <netinet/in.h>
#include <ctype.h>

#include "main.h"
#include "comstuff.h"
#include "sock.h"
#include "starflow.h"
#include "graph.h"
#include "ship.h"

static int sx, sy = -1;

void ppp ( int );

void ask_send_user ()
{
 struct player_name_pwd p;
 struct comfirm c;
 char side[10];
 char sid;

 again:;			/* I love gotos */

 printf ("Enter your name: ");
  gets ( p.name );
  strcpy ( p.passwd, getpass ("Enter your passwd: ") );
  p.udp = UDPport;
 printf ("Which side you choose?(R/E/T)");
 gets (side);
 switch ( toupper(side[0]) ) {
 	case 'R':
 		sid = SIDE_REBEL;
 		break;
	case 'E':
 		sid = SIDE_EMPIRE;
		break;
	case 'T':
 		sid = SIDE_TOURIST;
		break;
	default:
		printf ("No such side %c!\n", side[0]);
		goto again;
 }
 
 p.side = sid;

 if ( write_data ( TCPsock, &p, sizeof ( struct player_name_pwd ) ) <= 0 )
 	exit_prog ();

 if ( read_data ( TCPsock, &c, sizeof ( struct comfirm ) ) <= 0 )
 	exit_prog ();

 switch ( c.status ) {
 	case ST_OK:
 		printf ("Status OK! Moving on...\n");
 		break;
	case ST_W_PW:
		printf ("Wrong passwd!\n");
		goto again;
		break;	/* :) */
	default:
		printf ("Unknown status %d\n", c.status );
		goto again;
		break;
 }

#ifdef __linux__
 ((struct sockaddr_in *)sock_to) -> sin_port = htons ( c.port );
#else
 ppp ( htons ( c.port ) );
#endif
 printf ("Sending keydata to %d\n", c.port );

}

void start_game ()
{
 struct comfirm c;

 printf ("Starting game...\n");

 c.status = ST_ST_G;

 if ( write_data ( TCPsock, &c, sizeof ( struct comfirm ) ) <= 0 )
 	exit_prog ();

}

void delete_ships ()
{
 int i;
 struct header *h;
 struct body_bs *q;
 struct body_ms *b;
 struct body_obj *o;
 char *buf;
 if ( MODE == MODE_DOUBLE_BUFFERING || MODE == MODE_DIRTY_RECTANGLES )
   if ( !CP ) buf = mem2;
          else buf = mem1;
  else
   if ( CP ) buf = mem2;
          else buf = mem1;

 h = ( struct header *) buf;
 for ( i=0; i<h->ms; i++ ) {
  b = ( struct body_ms * ) (buf + sizeof ( struct header ) + sizeof ( struct body_ms ) * i);
 if ( b->x + (WIDTH>>1) + (ships[b->type]->imgs[b->rot]->w>>1) >= 0     &&
      b->x + (WIDTH>>1) - (ships[b->type]->imgs[b->rot]->w>>1) <= WIDTH &&
      b->y + (HEIGHT>>1) + (ships[b->type]->imgs[b->rot]->h>>1) >= 0    &&
      b->y + (HEIGHT>>1) - (ships[b->type]->imgs[b->rot]->h>>1) <= HEIGHT )
  my_del_cbitmap ( scr, ships[b->type]->imgs[b->rot], b->x + (WIDTH>>1) - (ships[b->type]->imgs[b->rot]->w>>1), b->y+(HEIGHT>>1) - (ships[b->type]->imgs[b->rot]->h>>1) );
/*  my_fillbox ( scr, b->x + (WIDTH>>1) - (ships[b->type]->imgs[b->rot]->w>>1), b->y+(HEIGHT>>1) - (ships[b->type]->imgs[b->rot]->h>>1), ships[b->type]->imgs[b->rot]->w, ships[b->type]->imgs[b->rot]->h, 0 );  */
 }

 for ( i=0; i<h->objs; i++ ) {
 o = ( struct body_obj * ) (buf + sizeof ( struct header ) + sizeof ( struct body_ms ) * h->ms + sizeof ( struct body_obj ) * i );
 if ( o->x + (WIDTH>>1) + (ships[o->type]->imgs[o->rot]->w>>1) >= 0     &&
      o->x + (WIDTH>>1) - (ships[o->type]->imgs[o->rot]->w>>1) <= WIDTH &&
      o->y + (HEIGHT>>1) + (ships[o->type]->imgs[o->rot]->h>>1) >= 0    &&
      o->y + (HEIGHT>>1) - (ships[o->type]->imgs[o->rot]->h>>1) <= HEIGHT )
  my_del_cbitmap ( scr, ships[o->type]->imgs[o->rot], o->x + (WIDTH>>1) - (ships[o->type]->imgs[o->rot]->w>>1), o->y+(HEIGHT>>1) - (ships[o->type]->imgs[o->rot]->h>>1) );
/*  my_fillbox ( scr, o->x + (WIDTH>>1) - (ships[o->type]->imgs[o->rot]->w>>1), o->y+(HEIGHT>>1) - (ships[o->type]->imgs[o->rot]->h>>1), ships[o->type]->imgs[o->rot]->w, ships[o->type]->imgs[o->rot]->h, 0 );  */
 }

 for ( i=0; i<h->bs; i++ ) {
  q = ( struct body_bs * ) (buf + sizeof ( struct header ) + sizeof ( struct body_ms ) * h->ms + sizeof ( struct body_obj ) * h->objs + sizeof ( struct body_bs ) * i );
 if ( q->x + (WIDTH>>1) + (ships[q->type]->imgs[q->rot]->w>>1) >= 0     &&
      q->x + (WIDTH>>1) - (ships[q->type]->imgs[q->rot]->w>>1) <= WIDTH &&
      q->y + (HEIGHT>>1) + (ships[q->type]->imgs[q->rot]->h>>1) >= 0    &&
      q->y + (HEIGHT>>1) - (ships[q->type]->imgs[q->rot]->h>>1) <= HEIGHT )
  my_del_cbitmap ( scr, ships[q->type]->imgs[q->rot], q->x + (WIDTH>>1) - (ships[q->type]->imgs[q->rot]->w>>1), q->y+(HEIGHT>>1) - (ships[q->type]->imgs[q->rot]->h>>1) );
 }


}

void work_comms ( char *buf, int l)
{
 int i;
 struct header *h;
 struct body_ms *b;
 struct body_bs *q;
 struct body_obj *o;

 h = ( struct header *) buf;

 if ( sy == -1 ) {
     sx = h->x;
     sy = h->y;
 }

 if ( MODE == MODE_DIRTY_RECTANGLES ) my_vsync ();
 delete_starflow ();
 delete_ships ();
 move_draw_starflow ( sx - h->x, h->y - sy ); 
 sx = h->x;
 sy = h->y;

 for ( i=0; i<h->objs; i++ ) {
  o = ( struct body_obj * ) (buf + sizeof ( struct header ) + sizeof ( struct body_ms ) * h->ms + sizeof ( struct body_obj ) * i );
 if ( o->x + (WIDTH>>1) + (ships[o->type]->imgs[o->rot]->w>>1) >= 0     &&
      o->x + (WIDTH>>1) - (ships[o->type]->imgs[o->rot]->w>>1) <= WIDTH &&
      o->y + (HEIGHT>>1) + (ships[o->type]->imgs[o->rot]->h>>1) >= 0    &&
      o->y + (HEIGHT>>1) - (ships[o->type]->imgs[o->rot]->h>>1) <= HEIGHT ) { 
  my_put_cbitmap ( scr, ships[o->type]->imgs[o->rot], o->x + (WIDTH>>1) - (ships[o->type]->imgs[o->rot]->w>>1), o->y+(HEIGHT>>1) - (ships[o->type]->imgs[o->rot]->h>>1) );
  }
 }

 for ( i=0; i<h->ms; i++ ) {
  b = ( struct body_ms * ) (buf + sizeof ( struct header ) + sizeof ( struct body_ms ) * i);
 if ( b->x + (WIDTH>>1) + (ships[b->type]->imgs[b->rot]->w>>1) >= 0     &&
      b->x + (WIDTH>>1) - (ships[b->type]->imgs[b->rot]->w>>1) <= WIDTH &&
      b->y + (HEIGHT>>1) + (ships[b->type]->imgs[b->rot]->h>>1) >= 0    &&
      b->y + (HEIGHT>>1) - (ships[b->type]->imgs[b->rot]->h>>1) <= HEIGHT )
  my_put_cbitmap ( scr, ships[b->type]->imgs[b->rot], b->x + (WIDTH>>1) - (ships[b->type]->imgs[b->rot]->w>>1), b->y+(HEIGHT>>1) - (ships[b->type]->imgs[b->rot]->h>>1) );
 }

 for ( i=0; i<h->bs; i++ ) {
  q = ( struct body_bs * ) (buf + sizeof ( struct header ) + sizeof ( struct body_ms ) * h->ms + sizeof ( struct body_obj ) * h->objs + sizeof ( struct body_bs ) * i );
 if ( q->x + (WIDTH>>1) + (ships[q->type]->imgs[q->rot]->w>>1) >= 0     &&
      q->x + (WIDTH>>1) - (ships[q->type]->imgs[q->rot]->w>>1) <= WIDTH &&
      q->y + (HEIGHT>>1) + (ships[q->type]->imgs[q->rot]->h>>1) >= 0    &&
      q->y + (HEIGHT>>1) - (ships[q->type]->imgs[q->rot]->h>>1) <= HEIGHT )
  my_put_cbitmap ( scr, ships[q->type]->imgs[q->rot], q->x + (WIDTH>>1) - (ships[q->type]->imgs[q->rot]->w>>1), q->y+(HEIGHT>>1) - (ships[q->type]->imgs[q->rot]->h>>1) );
 }

 change_screens ();	/* And blast it on the screen */
}
