
struct player_name_pwd {
	char	name[25];
	char	passwd[25];
	int	udp;
	int	side;
}__attribute__((packed));


struct header {
	unsigned short	count;
	unsigned short	objs;	/* AI ships/asteroids */
	unsigned char	ms;	/* players */
	unsigned char	bs;	/* Bullets */
	unsigned int	x;
	unsigned int	y;	/* World coordinates */
}__attribute__((packed));

struct body_obj {
	unsigned char	rot;
	short	x;
	short	y;
	unsigned char	type;
}__attribute__((packed));					/* 6 bytes */

struct body_bs {
	unsigned char	type;
	unsigned char	rot;
	short	x;
	short	y;
}__attribute__((packed));					/* 6 bytes */

struct body_ms {
	unsigned char	type;
	unsigned char	rot;
	short	x;
	short	y;
	unsigned short	br;
}__attribute__((packed));					/* 8 bytes */



struct comfirm {
	int	status;
	int	port;
}__attribute__((packed));

#define REQ_PLAYERS	1
#define REQ_MOTD	2
#define REQ_SEND_MESS	3

struct request {
	int	command;
	char	data[80];
}__attribute__((packed));

#define S_W_N   1	/* Wait name/passwd/udpport */
#define S_W_G   2	/* Wait game confirmation */
#define S_I_G	3	/* In game */

#define ST_OK	5	/* Global */
#define ST_ST_G 6	/* Start game! */
#define ST_W_PW 7	/* Wrong passwd */
#define ST_DEN  8	/* Denied */

#define K_SP_UP		1
#define K_SP_DOWN	2
#define K_LEFT		4
#define K_RIGHT		8
#define K_SHOOT		16

#define SIDE_REBEL      1
#define SIDE_EMPIRE     2
#define SIDE_TOURIST    3

