#ifndef ___farptrx_h___
#define ___farptrx_h___

extern __inline__ void _farpokex (unsigned short selector, unsigned long offset, void *x, int len)
{
  __asm__ __volatile__ ("pushl %%es\n"
                        "movw %w0,%%es\n"
                        "rep\n"
                        "movsb\n"
                        "popl %%es"
      :
      : "rm" (selector), "S" (x), "D" (offset), "c" (len));
}

extern __inline__ void _farpeekx (unsigned short selector, unsigned long offset, void *x, int len)
{
  __asm__ __volatile__ ("pushl %%ds\n"
                        "movw %w0,%%ds\n"
                        "rep\n"
                        "movsb\n"
                        "popl %%ds"
      :
      : "rm" (selector), "S" (offset), "D" (x), "c" (len));
}

#endif
