
#include <stdio.h>
#include <stdlib.h>

#include <mylib.h>	/* Must change it to server privat library some day... */

#include "bullet.h"
#include "main.h"
#include "loop.h"
#include "player.h"
#include "object.h"
#include "ship.h"

BULLET *bults;

void init_bults ()
{

 bults = malloc ( sizeof ( BULLET ) );
 bults->prev = NULL;
 bults->next = NULL;

}

BULLET * add_bullet ( unsigned long long x, unsigned long long y, int rot, int type, int anglex, int angley, int timeout )
{
 bults->next = malloc ( sizeof ( BULLET ) );
 bults->next->prev = bults;
 bults->next->next = NULL;

 bults->x = x;
 bults->y = y;
 bults->rot = rot;
 bults->type = type;
 bults->angx = anglex;
 bults->angy = angley;
 bults->timeout = timeout;
 bults = bults->next;

 return bults->prev;

}

BULLET * del_bullet ( BULLET *p )
{

 if ( p->prev == NULL ) {
   BULLET *tmp;
   tmp = p->next;
   free ( p );
   tmp->prev = NULL;
   return tmp;
 } else {
   BULLET *tmp1;
   BULLET *tmp2;
   tmp1 = p->next;
   tmp2 = p->prev;
   tmp1->prev = tmp2;
   tmp2->next = tmp1;
   free ( p );
   return tmp1;
 }

}

void check_bults ()
{
 BULLET *b;
 OBJECT *o;

 b = bults;

 while ( b->prev != NULL ) {
   b = b->prev;
   b->timeout --;
   if ( b->timeout == 0 ) b = del_bullet ( b );
 }

 b = bults;
 o = objs;

 while (  b->prev != NULL ) {
   b = b->prev;
   o = objs;

   while ( o->prev != NULL ) {
     o = o->prev;
     switch ( o->type ) {
     	case OBJ_E_DROID:
     	case OBJ_STRDSTR:
     	case OBJ_FRIGAT:
     	case OBJ_R_R2D2:
	     	if ( labs((o->x - b->x)>>14) < (ships[o->type]->w>>1) &&
	     	     labs((o->y - b->y)>>14) < (ships[o->type]->h>>1) )
	     	     	if ( *(ships[o->type]->imgs[o->rot]->data + (ships[o->type]->h>>1) * ships[o->type]->w + (ships[o->type]->w>>1) + ((b->x - o->x)>>14) + (( b->y - o->y )>>14) * ships[o->type]->w ) != 0 ) {
/*	     	     	printf ("%d\n", (int) ((ships[o->type]->h>>1) * ships[o->type]->w + (ships[o->type]->w>>1) + ((b->x - o->x)>>14) + (( b->y - o->y )>>14) * ships[o->type]->w)); */
	     	     		b->type = 29;
	     	     		b->timeout = 1;
	     	     		b->rot = 0;
	     	        }
     		break;
     }
   }
 }
}


