			/* Same numbers in player.h ship types */
#define OBJ_E_DROID	24
#define OBJ_R_R2D2	25
#define OBJ_STRDSTR	26
#define OBJ_FRIGAT	27
#define BULLET_GREEN	28
#define L_EXPLOSION	29

typedef struct OBJECT {
	unsigned long long	x;
	unsigned long long	y;
	int		rot;
	int		type;
	int		angx;
	int		angy;

	struct OBJECT	*next;
	struct OBJECT	*prev;
} OBJECT;

extern OBJECT *objs;

OBJECT * add_object ( unsigned long long, unsigned long long, int, int, int, int );
OBJECT * del_object ( OBJECT * );
void call_speed_obj ( OBJECT *, int, int );

