		/* Same numbers in object.h - objects numbers */
#define SHIP_XWING	1
#define SHIP_AWING	2
#define SHIP_BWING	3
#define SHIP_YWING	4
#define SHIP_TIE_I	5
#define SHIP_TIE_B	6
#define SHIP_TIE_F	7
#define SHIP_TIE_DV	8

#include <netinet/in.h>

struct USER;

typedef struct PLAYER {
	int	sock;
	int	udp;
	int	sockudp;
	int	portudp;
	struct	sockaddr_in	player_in;

	int	status;

	unsigned long long	x;
	unsigned long long	y;
	int	rot;
	int	angx;
	int	angy;
	int	side;
	int	type;

	char	name[256];
	char	passwd[256];
	int	exp;

	struct USER	*user;

	struct	PLAYER	*next;
	struct	PLAYER	*prev;
}PLAYER;

extern PLAYER *plys;
extern int PLAYERS;

PLAYER * add_player ( void );
PLAYER * rem_player ( PLAYER * );
void init_players ( void );

PLAYER * read_name ( PLAYER * );
void act_player ( PLAYER *, char * );
PLAYER * read_confirm ( PLAYER * );
PLAYER * read_requests ( PLAYER * );



