
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "spacenode.h"
#include "main.h"
#include "object.h"

int NODES;
struct SPACENODE *nodes[256];

void load_map ( char *fname )
{
 FILE *fl;
 int i,j,tmp;
 char rfname[1024];

 if ( access ( fname, F_OK ) != 0 )
 	sprintf ( rfname, "/usr/games/lib/gama2/%s", fname );
   else strcpy ( rfname, fname );

 if ( ( fl = fopen ( rfname, "r" ) ) == NULL ) {
 	perror ("fopen");
 	fprintf (stderr, "Error opening file %s\n", rfname );
 	exit (0);
 }

  fscanf ( fl, "%d", &j );
  NODES = j;

  for ( i=0; i<j; i++ ) {
   fscanf ( fl, "%d", &tmp );
   nodes[tmp] = malloc ( sizeof ( struct SPACENODE ) );
    fscanf (fl, "%d %d %d %d", &nodes[tmp]->x, &nodes[tmp]->y, &nodes[tmp]->owner, &nodes[tmp]->type );
    if ( tmp == 1 ) add_object ( nodes[tmp]->x<<14, nodes[tmp]->y<<14, 0, 27, 0, 0 );
    if ( tmp == 2 ) add_object ( nodes[tmp]->x<<14, nodes[tmp]->y<<14, 0, 26, 0, 0 );
  }

 fclose (fl);

}

