
#include "mylib.h"

BITMAP *my_rotate_bitmap ( BITMAP *b, int rot, int x0, int y0 )
{
 int i,j,x,y,w,h,xx,yy;
 BITMAP *n;

 n = my_create_bitmap ( b->w, b->h );

 w = b->w;
 h = b->h;
 xx = 0;
 yy = 0;
 while ( b->mb != NULL ) {
	xx += b->x;
	yy += b->y;
	b = b->mb;
 }

 while ( rot < 0 ) rot+=360;
 while ( rot > 360 ) rot -= 360;

 if ( b->type == BITMAP_MEMORY )
  for ( i=0; i<n->h; i++ )
   for ( j=0; j<n->w; j++ ) {
	x = ( (j-x0)*FCOS[rot] - (i-y0)*FSIN[rot])>>14;
	y = ( (j-x0)*FSIN[rot] + (i-y0)*FCOS[rot])>>14;
/*	x = (FROT[j+100-x0][rot][1] - FROT[i+100-y0][rot][0])>>14;
	y = (FROT[j+100-x0][rot][0] + FROT[i+100-y0][rot][1])>>14; */
	x += x0;
	y += y0;
	if ( x>=0 && y>=0 && x<b->w && y<b->h )
	* ( n->data + i * n->w + j ) = * ( b->data + (yy + y) * b->w + x + xx );
	else * ( n->data + i * n->w + j ) = 0;
   }
 else 
  for ( i=0; i<n->h; i++ )
   for ( j=0; j<n->w; j++ ) {
	x = ( (j-x0)*FCOS[rot] - (i-y0)*FSIN[rot])>>14;
	y = ( (j-x0)*FSIN[rot] + (i-y0)*FCOS[rot])>>14;
/*	x = (FROT[j+100-x0][rot][1] - FROT[i+100-y0][rot][0])>>14;
	y = (FROT[j+100-x0][rot][0] + FROT[i+100-y0][rot][1])>>14; */
	x += x0;
	y += y0;
	if ( x>=0 && y>=0 && x<b->w && y<b->h )
	* ( n->data + i * n->w + j ) = my_getpixel (b, x+xx, y+yy );
	else * ( n->data + i * n->w + j ) = 0;
   }

 return n;
 
}

