
#include <mylib.h>
#include <stdlib.h>
#include <unistd.h>

#include "ship.h"
#include "graph.h"
#include "main.h"

struct SHIP *ships[256];

void load_ships ( char *fname )
{
 FILE *fl;
 int i,j,tmp,c;
 char rfname[1024];

 if ( access ( fname, F_OK ) != 0 ) 
	 sprintf ( rfname, "/usr/games/lib/gama2/%s", fname );
    else strcpy ( rfname, fname );

 if ( ( fl = fopen ( rfname , "rb" ) ) == NULL ) {
 	printf ("Error opening %s!\n", rfname );
 	perror ("fopen");
 	exit (0);
 }
  fread ( &i, 4, 1, fl );
  ships[i] = malloc ( sizeof ( struct SHIP ) );
  printf ("Loding images for subject %d\n", i );
  fread ( &ships[i]->w, 4, 1, fl );
  fread ( &ships[i]->h, 4, 1, fl );
  fread ( &c, 4, 1, fl );
  printf ("It consist of %d images!\n", c);
  for ( j=0; j<c; j++ ) {
    ships[i]->imgs[j] = malloc ( sizeof ( struct CBITMAP ) );
    fread ( &tmp, 4, 1, fl );
    ships[i]->imgs[j]->data = malloc (tmp);
    if ( fread ( ships[i]->imgs[j]->data, tmp, 1, fl ) != 1 ) perror ("fread");
    ships[i]->imgs[j]->w = ships[i]->w;
    ships[i]->imgs[j]->h = ships[i]->h;
    ships[i]->imgs[j]->size = tmp;
  }
 fclose (fl);
}

