
#include <stdio.h>
#include <signal.h>

#include "player.h"
#include "main.h"

int GAMEPORT = 1997;

void sign (int v)
{
 printf ("Signal %d!\n", v );
 save_users ("users.file");
 exit (0);
}

int main( int argc, char *argv[])
{

 printf("MOOZd 1.0 <c> 1997 Indrek Mandre\n");

 init_tcp_socket ();

 load_ships ( "xwing.data" );
 load_ships ( "edroid.data" );
 load_ships ( "strdstr.data" );
 load_ships ( "awing.data" );
 load_ships ( "green_bullet.data" );
 load_ships ( "frigat.data" );
 load_ships ( "l_explosion.data" );

 init_players ();
 init_users ();
 init_objs ();
 init_bults ();

 init_math();

 load_map ("map");
 load_users ("users.file");

 signal ( SIGINT, sign );
 signal ( SIGHUP, sign );
 signal ( SIGQUIT, sign );
 signal ( SIGPIPE, sign );
 signal ( SIGFPE, sign );
 signal ( SIGTERM, sign );
 signal ( SIGSEGV, sign );

 loop ();

 return 0;
}


