
#include <stdio.h>
#include <stdlib.h>

#include "object.h"
#include "main.h"
#include "loop.h"
#include "player.h"

OBJECT *objs;

void init_objs ()
{
int i;
 objs = malloc ( sizeof ( OBJECT ) );
 objs->prev = NULL;
 objs->next = NULL;
 for ( i=0; i<100; i++ ) {	/* Just for fun */
 add_object ( (900 + random()%200)<<14, (900 + random()%200)<<14, random()%180, 24, -(1<<14)+random()%(2<<14), -(1<<14)+random()%(2<<14) );
 }
 for ( i=0; i<0; i++ )
  add_object ( (1000+random()%1000)<<14, (1000+random()%1000)<<14, 0, 29, 0, 0 );
}

OBJECT * add_object ( unsigned long long x, unsigned long long y, int rot, int type, int anglex, int angley )
{
 objs->next = malloc ( sizeof ( OBJECT ) );
 objs->next->prev = objs;
 objs->next->next = NULL;

 objs->x = x;
 objs->y = y;
 objs->rot = rot;
 objs->type = type;
 objs->angx = anglex;
 objs->angy = angley;
 objs = objs->next;

 return objs->prev;

}

OBJECT * del_object ( OBJECT *p )
{

 if ( p->prev == NULL ) {
   OBJECT *tmp;
   tmp = p->next;
   free ( p );
   tmp->prev = NULL;
   return tmp;
 } else {
   OBJECT *tmp1;
   OBJECT *tmp2;
   tmp1 = p->next;
   tmp2 = p->prev;
   tmp1->prev = tmp2;
   tmp2->next = tmp1;
   free ( p );
   return tmp1;
 }

}

void check_objs ()
{
 OBJECT *o;

 o = objs;

 while ( o->prev != NULL ) {
   o = o->prev;
   switch ( o->type ) {
   	case OBJ_E_DROID:
   		o->rot ++;
   		if ( o->rot == 180 ) o->rot = 0;
   		break;
	case OBJ_R_R2D2:
   		o->rot ++;
   		if ( o->rot == 180 ) o->rot = 0;
		break;
	default:
/*		printf ("What damned type object?!\n"); this history now */
		break;
   }
 }

}
