
#include <mylib.h>
#include <stdlib.h>
#include <unistd.h>

#include "ship.h"
#include "main.h"

struct SHIP *ships[256];

void load_ships ( char *fname )
{
 FILE *fl;
 int i,j,tmp,c;
 CBITMAP *cbm;
 char rfname[1024];

 if ( access ( fname, F_OK ) != 0 )
         sprintf ( rfname, "/usr/games/lib/gama2/%s", fname );
    else strcpy ( rfname, fname );

 if ( ( fl = fopen ( rfname , "rb" ) ) == NULL ) {
 	printf ("Error opening %s!\n", rfname );
 	perror ("fopen");
 	exit (0);
 }

  fread ( &i, 4, 1, fl );

  ships[i] = malloc ( sizeof ( struct SHIP ) );

  cbm = malloc ( sizeof ( CBITMAP ) );

  printf ("Loding images for subject %d\n", i );

  fread ( &ships[i]->w, 4, 1, fl );
  fread ( &ships[i]->h, 4, 1, fl );

  cbm->w = ships[i]->w;
  cbm->h = ships[i]->h;

  fread ( &c, 4, 1, fl );

  printf ("It consist of %d images!\n", c);

  for ( j=0; j<c; j++ ) {

    ships[i]->imgs[j] = my_create_bitmap ( ships[i]->w, ships[i]->h );
  
    fread ( &tmp, 4, 1, fl );
    cbm->data = malloc ( tmp );
    cbm->size = tmp;
if ( cbm->data == NULL ) {perror ("VIGA!\n");
printf ("Size: %d\n", tmp );
}
    if ( fread ( cbm->data, tmp, 1, fl ) != 1 ) perror ("fread");
    my_put_cbitmap ( ships[i]->imgs[j], cbm, 0, 0 );
    free ( cbm->data ); 

  }
  free (cbm);
fclose (fl);
 return ;
  free (cbm);
 fclose (fl);
}

